#include <errno.h>
#include <dpmi.h>

#include "defs.h"

void __dpmi_begin_critical_section(void)
{
  __dpmi_regs r;

  r.x.ax = 0x1681;
  r.x.ss = r.x.sp = r.x.flags = 0;
  __dpmi_simulate_real_mode_interrupt (0x2f, &r);
}

void __dpmi_end_critical_section(void)
{
  __dpmi_regs r;

  r.x.ax = 0x1682;
  r.x.ss = r.x.sp = r.x.flags = 0;
  __dpmi_simulate_real_mode_interrupt (0x2f, &r);
}
