#include <dir.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <crt0.h>

char     From_[]="\nFrom ";

void __crt0_load_environment_file(char * x)
{}


char *chktmp(char *path)
{
FILE *fp;

if ( (fp=fopen(path,"r")) == NULL )
   return(path);
else
   fclose(fp);
return( NULL );
}

char * unique(char *inpath, char *ext)
{
static char   path[MAXPATH];

char *p;
int   n;

/*
 * Get the time of day in hex seconds since 1970 to use as a "random"
 * number for this file. The result is 8 hex digits plus NULL, we will
 * use the last 5 digits.
 */

strcpy(path, inpath);
if (path[(n=strlen(path)) - 1] != '\\' )
   {
   strcat(path, "\\");
   n++;
   }

if (n>= MAXPATH -13)
   {
   fputs("Cannot create an output filename\n",stderr);
   exit( -1 );
   }

p=path+n;
itoa(time(NULL),p,16);                  // It is obviously not supposed to
                                        // use this fuction before 0x1000
strcat(path,ext);
for(p[0]='A';p[0]<='Z';p[0]++)
   for(p[1]='A';p[1]<='Z';p[1]++)
      for(p[2]='A';p[2]<='Z';p[2]++)
         if (chktmp(path) != NULL )
            return(path);

fputs("Cannot create an output filename\n",stderr);
exit( -1 );
}

void usage()
{
printf("Usage: UU2PM [-d] <src_file> <dir for .CNM>\n");
exit(-1);
}

int main( int argc, char* argv[] )
{
FILE *src;
FILE *dst=NULL;
int   delinp,c,n=0;

char            Fcmp[sizeof(From_)];

printf("UUPC/@ mailbox to Pegasus Mail converter version 1.2\n");
if (argc!=2)

if (argc==3)
   delinp=0;
else
   if ((argc==4) && (strcmp(argv[1], "-d") == 0))
      {
      delinp=-1;
      argv[1]=argv[2];
      argv[2]=argv[3];
      }
   else
      usage();

if ((src=fopen(argv[1],"rt"))==NULL)
   usage();


Fcmp[0]='\n';
Fcmp[sizeof(Fcmp)-2]=Fcmp[sizeof(Fcmp)-1]=0;
fread(Fcmp+1,1,sizeof(Fcmp)-3,src);

while ((c=getc(src))!=EOF)
      {
      Fcmp[sizeof(Fcmp)-2]=c;
      if (strcmp(Fcmp,From_)==0)
         {
         if (dst!=NULL)
            fclose(dst);

         if ( (dst=fopen(unique(argv[2],".cnm"),"wt")) == NULL )
              {
              fputs("Error in opening an output file\n",stderr);
              exit(-1);
              }

         fputs("Recieved: from ",dst);
         
         //while (((c=getc(src))!=EOF) && c!='\n');

         Fcmp[sizeof(Fcmp)-2]=0;
         fread(Fcmp,1,sizeof(Fcmp)-2,src);
         printf("\r %d messages developed",n++);
         fflush(stdout);
         }
      else
         {
         if (dst!=NULL)
            fputc(Fcmp[0],dst);
         Fcmp[0]=Fcmp[1];       // \nFrom_
         Fcmp[1]=Fcmp[2];       //  012345
         Fcmp[2]=Fcmp[3];
         Fcmp[3]=Fcmp[4];
         Fcmp[4]=Fcmp[5];
         }
      }

for (c=0;c<sizeof(From_)-2;c++)
        fputc(Fcmp[c],dst);

fclose(dst);
fclose(src);

printf("\r %d messages developed",n);

if ((delinp) && (unlink(argv[1]) != 0 ))
   {
   fputs("Could not delete input file\n",stderr);
   exit(-1);
   }

return(0);
}
